image: node:20

stages:
    - test
    - deploy

before_script:
    - eval `ssh-agent -s`
    - echo "${SSH_PRIVATE_KEY}" | base64 --decode -- | tr -d '\r' | ssh-add - > /dev/null # add ssh key
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - git checkout $CI_COMMIT_REF_NAME
    - git remote set-url origin "git@gitlab.com:$CI_PROJECT_PATH.git"
    - git config --global user.name "${CI_USERNAME}"
    - git config --global user.email "${CI_EMAIL}"
    - git fetch origin --tags

test:
    except:
        - develop
        - main
        - tags
    stage: test
    script:
        - yarn install
        - yarn run lint
        - yarn run build
        - yarn run check-exports
        - yarn run test

publish-beta:
    only:
        - develop
    stage: deploy
    script:
        - echo "@trixtajs2:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/" > .npmrc
        - echo "//${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
        - yarn install
        - yarn run lint
        - yarn run build
        - yarn run check-exports
        - yarn run test
        - yarn run "release:beta"

publish:
    only:
        - main
    stage: deploy
    script:
        - echo "@trixtajs2:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/" > .npmrc
        - echo "//${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
        - yarn install
        - yarn run lint
        - yarn run build
        - yarn run check-exports
        - yarn run test
        - yarn run "release:prod"
